#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <ucontext.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <iostream>
#include <boost/asio.hpp>

using namespace std;

int
main(int argc, char *argv[])
{
  int fd;
  boost::asio::io_service service;

  // #########################################################
  // On test s'il y a un argument sur la ligne de cœommande pour avoir un message à échanger
  // #########################################################
  //assert(argc == 2);
  if (argc != 3) {
    fprintf(stderr, "Usage %s <nom fifo> \"un truc\" pour faire passer le message un truc\n", argv[0]);
    exit(2);
  }
  
  fd = open(argv[1], O_WRONLY);
  if (fd <= 0) {
    fprintf(stderr, "probleme avec l'ouverture du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }
  boost::asio::posix::stream_descriptor streampipe(service);
  streampipe.assign(fd);

  boost::system::error_code error;
  string message = argv[2];
  write(streampipe, boost::asio::buffer(message.c_str(), message.size()),error);
  if (error) {
    cerr << "impossible d'écrire dans le pipe car " << error.message() << endl;
    exit(1);
  }

  cout << "Fin de la liaison" << endl;

  streampipe.close();
  close(fd);

  return 0;
}
